
#ifndef __C35_LIBRARY_H
#define __C35_LIBRARY_H

#include <stdio.h>
#include <map>
#include "../common/library.h"
#include "./c35_comb.h"
#include "./c35_seq.h"
//PB
#include "./c35_memory.h"

using namespace std;

class c35_library : public library {
public:
	map<string, int> gates;

	c35_library () : library ("AustriaMicroSystems C35") {

	gates["ADD21"] = 1;
	gates["ADD22"] = 2;
	gates["ADD31"] = 3;
	gates["ADD32"] = 4;
	gates["AOI210"] = 5;
	gates["AOI211"] = 6;
	gates["AOI2110"] = 7;
	gates["AOI2111"] = 8;
	gates["AOI2112"] = 9;
	gates["AOI212"] = 10;
	gates["AOI220"] = 11;
	gates["AOI221"] = 12;
	gates["AOI222"] = 13;
	gates["AOI310"] = 14;
	gates["AOI311"] = 15;
	gates["AOI312"] = 16;
	gates["BUF12"] = 17;
	gates["BUF15"] = 18;
	gates["BUF2"] = 19;
	gates["BUF4"] = 20;
	gates["BUF6"] = 21;
	gates["BUF8"] = 22;
	gates["BUFE10"] = 23;
	gates["BUFE12"] = 24;
	gates["BUFE15"] = 25;
	gates["BUFE2"] = 26;
	gates["BUFE4"] = 27;
	gates["BUFE6"] = 28;
	gates["BUFE8"] = 29;
	gates["BUFT10"] = 30;
	gates["BUFT12"] = 31;
	gates["BUFT15"] = 32;
	gates["BUFT2"] = 33;
	gates["BUFT4"] = 34;
	gates["BUFT6"] = 35;
	gates["BUFT8"] = 36;
	gates["CLKBU12"] = 37;
	gates["CLKBU15"] = 38;
	gates["CLKBU2"] = 39;
	gates["CLKBU4"] = 40;
	gates["CLKBU6"] = 41;
	gates["CLKBU8"] = 42;
	gates["CLKIN0"] = 43;
	gates["CLKIN1"] = 44;
	gates["CLKIN10"] = 45;
	gates["CLKIN12"] = 46;
	gates["CLKIN15"] = 47;
	gates["CLKIN2"] = 48;
	gates["CLKIN3"] = 49;
	gates["CLKIN4"] = 50;
	gates["CLKIN6"] = 51;
	gates["CLKIN8"] = 52;
	gates["DF1"] = 53;
	gates["DF3"] = 54;
	gates["DFC1"] = 55;
	gates["DFC3"] = 56;
	gates["DFCP1"] = 57;
	gates["DFCP3"] = 58;
	gates["DFE1"] = 59;
	gates["DFE3"] = 60;
	gates["DFEC1"] = 61;
	gates["DFEC3"] = 62;
	gates["DFECP1"] = 63;
	gates["DFECP3"] = 64;
	gates["DFEP1"] = 65;
	gates["DFEP3"] = 66;
	gates["DFP1"] = 67;
	gates["DFP3"] = 68;
	gates["DFS1"] = 69;
	gates["DFS3"] = 70;
	gates["DFSC1"] = 71;
	gates["DFSC3"] = 72;
	gates["DFSCP1"] = 73;
	gates["DFSCP3"] = 74;
	gates["DFSE1"] = 75;
	gates["DFSE3"] = 76;
	gates["DFSEC1"] = 77;
	gates["DFSEC3"] = 78;
	gates["DFSECP1"] = 79;
	gates["DFSECP3"] = 80;
	gates["DFSEP1"] = 81;
	gates["DFSEP3"] = 82;
	gates["DFSP1"] = 83;
	gates["DFSP3"] = 84;
	gates["DL1"] = 85;
	gates["DL3"] = 86;
	gates["DLC1"] = 87;
	gates["DLC3"] = 88;
	gates["DLCP1"] = 89;
	gates["DLCP3"] = 90;
	gates["DLCPQ1"] = 91;
	gates["DLCPQ3"] = 92;
	gates["DLCQ1"] = 93;
	gates["DLCQ3"] = 94;
	gates["DLP1"] = 95;
	gates["DLP3"] = 96;
	gates["DLPQ1"] = 97;
	gates["DLPQ3"] = 98;
	gates["DLQ1"] = 99;
	gates["DLQ3"] = 100;
	gates["DLY12"] = 101;
	gates["DLY22"] = 102;
	gates["DLY32"] = 103;
	gates["DLY42"] = 104;
	gates["IMAJ30"] = 105;
	gates["IMAJ31"] = 106;
	gates["IMUX20"] = 107;
	gates["IMUX21"] = 108;
	gates["IMUX22"] = 109;
	gates["IMUX23"] = 110;
	gates["IMUX24"] = 111;
	gates["IMUX30"] = 112;
	gates["IMUX31"] = 113;
	gates["IMUX32"] = 114;
	gates["IMUX33"] = 115;
	gates["IMUX40"] = 116;
	gates["IMUX41"] = 117;
	gates["IMUX42"] = 118;
	gates["INV0"] = 119;
	gates["INV1"] = 120;
	gates["INV10"] = 121;
	gates["INV12"] = 122;
	gates["INV15"] = 123;
	gates["INV2"] = 124;
	gates["INV3"] = 125;
	gates["INV4"] = 126;
	gates["INV6"] = 127;
	gates["INV8"] = 128;
	gates["JK1"] = 129;
	gates["JK3"] = 130;
	gates["JKC1"] = 131;
	gates["JKC3"] = 132;
	gates["JKCP1"] = 133;
	gates["JKCP3"] = 134;
	gates["JKP1"] = 135;
	gates["JKP3"] = 136;
	gates["JKS1"] = 137;
	gates["JKS3"] = 138;
	gates["JKSC1"] = 139;
	gates["JKSC3"] = 140;
	gates["JKSCP1"] = 141;
	gates["JKSCP3"] = 142;
	gates["JKSP1"] = 143;
	gates["JKSP3"] = 144;
	gates["MAJ31"] = 145;
	gates["MAJ32"] = 146;
	gates["MUX21"] = 147;
	gates["MUX22"] = 148;
	gates["MUX24"] = 149;
	gates["MUX26"] = 150;
	gates["MUX31"] = 151;
	gates["MUX32"] = 152;
	gates["MUX33"] = 153;
	gates["MUX34"] = 154;
	gates["MUX41"] = 155;
	gates["MUX42"] = 156;
	gates["MUX43"] = 157;
	gates["NAND20"] = 158;
	gates["NAND21"] = 159;
	gates["NAND22"] = 160;
	gates["NAND23"] = 161;
	gates["NAND24"] = 162;
	gates["NAND26"] = 163;
	gates["NAND28"] = 164;
	gates["NAND30"] = 165;
	gates["NAND31"] = 166;
	gates["NAND32"] = 167;
	gates["NAND33"] = 168;
	gates["NAND34"] = 169;
	gates["NAND40"] = 170;
	gates["NAND41"] = 171;
	gates["NAND42"] = 172;
	gates["NAND43"] = 173;
	gates["NOR20"] = 174;
	gates["NOR21"] = 175;
	gates["NOR22"] = 176;
	gates["NOR23"] = 177;
	gates["NOR24"] = 178;
	gates["NOR30"] = 179;
	gates["NOR31"] = 180;
	gates["NOR32"] = 181;
	gates["NOR33"] = 182;
	gates["NOR40"] = 183;
	gates["NOR41"] = 184;
	gates["NOR42"] = 185;
	gates["OAI210"] = 186;
	gates["OAI211"] = 187;
	gates["OAI2110"] = 188;
	gates["OAI2111"] = 189;
	gates["OAI2112"] = 190;
	gates["OAI212"] = 191;
	gates["OAI220"] = 192;
	gates["OAI221"] = 193;
	gates["OAI222"] = 194;
	gates["OAI310"] = 195;
	gates["OAI311"] = 196;
	gates["OAI312"] = 197;
	gates["TFC1"] = 198;
	gates["TFC3"] = 199;
	gates["TFCP1"] = 200;
	gates["TFCP3"] = 201;
	gates["TFEC1"] = 202;
	gates["TFEC3"] = 203;
	gates["TFECP1"] = 204;
	gates["TFECP3"] = 205;
	gates["TFEP1"] = 206;
	gates["TFEP3"] = 207;
	gates["TFP1"] = 208;
	gates["TFP3"] = 209;
	gates["TFSC1"] = 210;
	gates["TFSC3"] = 211;
	gates["TFSCP1"] = 212;
	gates["TFSCP3"] = 213;
	gates["TFSEC1"] = 214;
	gates["TFSEC3"] = 215;
	gates["TFSECP1"] = 216;
	gates["TFSECP3"] = 217;
	gates["TFSEP1"] = 218;
	gates["TFSEP3"] = 219;
	gates["TFSP1"] = 220;
	gates["TFSP3"] = 221;
	gates["XNR20"] = 222;
	gates["XNR21"] = 223;
	gates["XNR22"] = 224;
	gates["XNR30"] = 225;
	gates["XNR31"] = 226;
	gates["XNR40"] = 227;
	gates["XNR41"] = 228;
	gates["XOR20"] = 229;
	gates["XOR21"] = 230;
	gates["XOR22"] = 231;
	gates["XOR30"] = 232;
	gates["XOR31"] = 233;
	gates["XOR40"] = 234;
	gates["XOR41"] = 235;
	gates["BBC1P"] = 236;
	gates["BBC4P"] = 237;
	gates["BBC4SMP"] = 238;
	gates["BBC8P"] = 239;
	gates["BBC8SMP"] = 240;
	gates["BBC8SP"] = 241;
	gates["BBC16P"] = 242;
	gates["BBC16SMP"] = 243;
	gates["BBC16SP"] = 244;
	gates["BBC24P"] = 245;
	gates["BBC24SMP"] = 246;
	gates["BBC24SP"] = 247;
	gates["BBCD1P"] = 248;
	gates["BBCD4P"] = 249;
	gates["BBCD4SMP"] = 250;
	gates["BBCD8P"] = 251;
	gates["BBCD8SMP"] = 252;
	gates["BBCD8SP"] = 253;
	gates["BBCD16P"] = 254;
	gates["BBCD16SMP"] = 255;
	gates["BBCD16SP"] = 256;
	gates["BBCD24P"] = 257;
	gates["BBCD24SMP"] = 258;
	gates["BBCD24SP"] = 259;
	gates["BBCU1P"] = 260;
	gates["BBCU4P"] = 261;
	gates["BBCU4SMP"] = 262;
	gates["BBCU8P"] = 263;
	gates["BBCU8SMP"] = 264;
	gates["BBCU8SP"] = 265;
	gates["BBCU16P"] = 266;
	gates["BBCU16SMP"] = 267;
	gates["BBCU16SP"] = 268;
	gates["BBCU24P"] = 269;
	gates["BBCU24SMP"] = 270;
	gates["BBCU24SP"] = 271;
	gates["BBS1P"] = 272;
	gates["BBS4P"] = 273;
	gates["BBS4SMP"] = 274;
	gates["BBS8P"] = 275;
	gates["BBS8SMP"] = 276;
	gates["BBS8SP"] = 277;
	gates["BBS16P"] = 278;
	gates["BBS16SMP"] = 279;
	gates["BBS16SP"] = 280;
	gates["BBS24P"] = 281;
	gates["BBS24SMP"] = 282;
	gates["BBS24SP"] = 283;
	gates["BBSD1P"] = 284;
	gates["BBSD4P"] = 285;
	gates["BBSD4SMP"] = 286;
	gates["BBSD8P"] = 287;
	gates["BBSD8SMP"] = 288;
	gates["BBSD8SP"] = 289;
	gates["BBSD16P"] = 290;
	gates["BBSD16SMP"] = 291;
	gates["BBSD16SP"] = 292;
	gates["BBSD24P"] = 293;
	gates["BBSD24SMP"] = 294;
	gates["BBSD24SP"] = 295;
	gates["BBSU1P"] = 296;
	gates["BBSU4P"] = 297;
	gates["BBSU4SMP"] = 298;
	gates["BBSU8P"] = 299;
	gates["BBSU8SMP"] = 300;
	gates["BBSU8SP"] = 301;
	gates["BBSU16P"] = 302;
	gates["BBSU16SMP"] = 303;
	gates["BBSU16SP"] = 304;
	gates["BBSU24P"] = 305;
	gates["BBSU24SMP"] = 306;
	gates["BBSU24SP"] = 307;
	gates["BBT1P"] = 308;
	gates["BBT4P"] = 309;
	gates["BBT4SMP"] = 310;
	gates["BBT8P"] = 311;
	gates["BBT8SMP"] = 312;
	gates["BBT8SP"] = 313;
	gates["BBT16P"] = 314;
	gates["BBT16SMP"] = 315;
	gates["BBT16SP"] = 316;
	gates["BBT24P"] = 317;
	gates["BBT24SMP"] = 318;
	gates["BBT24SP"] = 319;
	gates["BBTD1P"] = 320;
	gates["BBTD4P"] = 321;
	gates["BBTD4SMP"] = 322;
	gates["BBTD8P"] = 323;
	gates["BBTD8SMP"] = 324;
	gates["BBTD8SP"] = 325;
	gates["BBTD16P"] = 326;
	gates["BBTD16SMP"] = 327;
	gates["BBTD16SP"] = 328;
	gates["BBTD24P"] = 329;
	gates["BBTD24SMP"] = 330;
	gates["BBTD24SP"] = 331;
	gates["BBTU1P"] = 332;
	gates["BBTU4P"] = 333;
	gates["BBTU4SMP"] = 334;
	gates["BBTU8P"] = 335;
	gates["BBTU8SMP"] = 336;
	gates["BBTU8SP"] = 337;
	gates["BBTU16P"] = 338;
	gates["BBTU16SMP"] = 339;
	gates["BBTU16SP"] = 340;
	gates["BBTU24P"] = 341;
	gates["BBTU24SMP"] = 342;
	gates["BBTU24SP"] = 343;
	gates["BT1P"] = 344;
	gates["BT2P"] = 345;
	gates["BT4P"] = 346;
	gates["BT4SMP"] = 347;
	gates["BT8P"] = 348;
	gates["BT8SMP"] = 349;
	gates["BT8SP"] = 350;
	gates["BT12P"] = 351;
	gates["BT12SMP"] = 352;
	gates["BT12SP"] = 353;
	gates["BT16P"] = 354;
	gates["BT16SMP"] = 355;
	gates["BT16SP"] = 356;
	gates["BT24P"] = 357;
	gates["BT24SMP"] = 358;
	gates["BT24SP"] = 359;
	gates["BU1P"] = 360;
	gates["BU2P"] = 361;
	gates["BU4P"] = 362;
	gates["BU4SMP"] = 363;
	gates["BU8P"] = 364;
	gates["BU8SMP"] = 365;
	gates["BU8SP"] = 366;
	gates["BU12P"] = 367;
	gates["BU12SMP"] = 368;
	gates["BU12SP"] = 369;
	gates["BU16P"] = 370;
	gates["BU16SMP"] = 371;
	gates["BU16SP"] = 372;
	gates["BU24P"] = 373;
	gates["BU24SMP"] = 374;
	gates["BU24SP"] = 375;
	gates["BUDD1P"] = 376;
	gates["BUDD2P"] = 377;
	gates["BUDD4P"] = 378;
	gates["BUDD8P"] = 379;
	gates["BUDD12P"] = 380;
	gates["BUDD16P"] = 381;
	gates["BUDD24P"] = 382;
	gates["BUDU1P"] = 383;
	gates["BUDU2P"] = 384;
	gates["BUDU4P"] = 385;
	gates["BUDU8P"] = 386;
	gates["BUDU12P"] = 387;
	gates["BUDU16P"] = 388;
	gates["BUDU24P"] = 389;
	gates["CBU1P"] = 390;
	gates["CBU2P"] = 391;
	gates["ICCK2P"] = 392;
	gates["ICCK4P"] = 393;
	gates["ICCK8P"] = 394;
	gates["ICCK16P"] = 395;
	gates["ICDP"] = 396;
	gates["ICP"] = 397;
	gates["ICUP"] = 398;
	gates["ISDP"] = 399;
	gates["ISP"] = 400;
	gates["ISUP"] = 401;
	gates["ITCK2P"] = 402;
	gates["ITCK4P"] = 403;
	gates["ITCK8P"] = 404;
	gates["ITCK16P"] = 405;
	gates["ITDP"] = 406;
	gates["ITP"] = 407;
	gates["ITUP"] = 408;
	gates["BBC1P_V5"] = 409;
	gates["BBC4P_V5"] = 410;
	gates["BBC4SMP_V5"] = 411;
	gates["BBC8P_V5"] = 412;
	gates["BBC8SMP_V5"] = 413;
	gates["BBC8SP_V5"] = 414;
	gates["BBC16P_V5"] = 415;
	gates["BBC16SMP_V5"] = 416;
	gates["BBC16SP_V5"] = 417;
	gates["BBC24P_V5"] = 418;
	gates["BBC24SMP_V5"] = 419;
	gates["BBC24SP_V5"] = 420;
	gates["BBCD1P_V5"] = 421;
	gates["BBCD4P_V5"] = 422;
	gates["BBCD4SMP_V5"] = 423;
	gates["BBCD8P_V5"] = 424;
	gates["BBCD8SMP_V5"] = 425;
	gates["BBCD8SP_V5"] = 426;
	gates["BBCD16P_V5"] = 427;
	gates["BBCD16SMP_V5"] = 428;
	gates["BBCD16SP_V5"] = 429;
	gates["BBCD24P_V5"] = 430;
	gates["BBCD24SMP_V5"] = 431;
	gates["BBCD24SP_V5"] = 432;
	gates["BBCU1P_V5"] = 433;
	gates["BBCU4P_V5"] = 434;
	gates["BBCU4SMP_V5"] = 435;
	gates["BBCU8P_V5"] = 436;
	gates["BBCU8SMP_V5"] = 437;
	gates["BBCU8SP_V5"] = 438;
	gates["BBCU16P_V5"] = 439;
	gates["BBCU16SMP_V5"] = 440;
	gates["BBCU16SP_V5"] = 441;
	gates["BBCU24P_V5"] = 442;
	gates["BBCU24SMP_V5"] = 443;
	gates["BBCU24SP_V5"] = 444;
	gates["BBS1P_V5"] = 445;
	gates["BBS4P_V5"] = 446;
	gates["BBS4SMP_V5"] = 447;
	gates["BBS8P_V5"] = 448;
	gates["BBS8SMP_V5"] = 449;
	gates["BBS8SP_V5"] = 450;
	gates["BBS16P_V5"] = 451;
	gates["BBS16SMP_V5"] = 452;
	gates["BBS16SP_V5"] = 453;
	gates["BBS24P_V5"] = 454;
	gates["BBS24SMP_V5"] = 455;
	gates["BBS24SP_V5"] = 456;
	gates["BBSD1P_V5"] = 457;
	gates["BBSD4P_V5"] = 458;
	gates["BBSD4SMP_V5"] = 459;
	gates["BBSD8P_V5"] = 460;
	gates["BBSD8SMP_V5"] = 461;
	gates["BBSD8SP_V5"] = 462;
	gates["BBSD16P_V5"] = 463;
	gates["BBSD16SMP_V5"] = 464;
	gates["BBSD16SP_V5"] = 465;
	gates["BBSD24P_V5"] = 466;
	gates["BBSD24SMP_V5"] = 467;
	gates["BBSD24SP_V5"] = 468;
	gates["BBSU1P_V5"] = 469;
	gates["BBSU4P_V5"] = 470;
	gates["BBSU4SMP_V5"] = 471;
	gates["BBSU8P_V5"] = 472;
	gates["BBSU8SMP_V5"] = 473;
	gates["BBSU8SP_V5"] = 474;
	gates["BBSU16P_V5"] = 475;
	gates["BBSU16SMP_V5"] = 476;
	gates["BBSU16SP_V5"] = 477;
	gates["BBSU24P_V5"] = 478;
	gates["BBSU24SMP_V5"] = 479;
	gates["BBSU24SP_V5"] = 480;
	gates["BBT1P_V5"] = 481;
	gates["BBT4P_V5"] = 482;
	gates["BBT4SMP_V5"] = 483;
	gates["BBT8P_V5"] = 484;
	gates["BBT8SMP_V5"] = 485;
	gates["BBT8SP_V5"] = 486;
	gates["BBT16P_V5"] = 487;
	gates["BBT16SMP_V5"] = 488;
	gates["BBT16SP_V5"] = 489;
	gates["BBT24P_V5"] = 490;
	gates["BBT24SMP_V5"] = 491;
	gates["BBT24SP_V5"] = 492;
	gates["BBTD1P_V5"] = 493;
	gates["BBTD4P_V5"] = 494;
	gates["BBTD4SMP_V5"] = 495;
	gates["BBTD8P_V5"] = 496;
	gates["BBTD8SMP_V5"] = 497;
	gates["BBTD8SP_V5"] = 498;
	gates["BBTD16P_V5"] = 499;
	gates["BBTD16SMP_V5"] = 500;
	gates["BBTD16SP_V5"] = 501;
	gates["BBTD24P_V5"] = 502;
	gates["BBTD24SMP_V5"] = 503;
	gates["BBTD24SP_V5"] = 504;
	gates["BBTU1P_V5"] = 505;
	gates["BBTU4P_V5"] = 506;
	gates["BBTU4SMP_V5"] = 507;
	gates["BBTU8P_V5"] = 508;
	gates["BBTU8SMP_V5"] = 509;
	gates["BBTU8SP_V5"] = 510;
	gates["BBTU16P_V5"] = 511;
	gates["BBTU16SMP_V5"] = 512;
	gates["BBTU16SP_V5"] = 513;
	gates["BBTU24P_V5"] = 514;
	gates["BBTU24SMP_V5"] = 515;
	gates["BBTU24SP_V5"] = 516;
	gates["BT1P_V5"] = 517;
	gates["BT2P_V5"] = 518;
	gates["BT4P_V5"] = 519;
	gates["BT4SMP_V5"] = 520;
	gates["BT8P_V5"] = 521;
	gates["BT8SMP_V5"] = 522;
	gates["BT8SP_V5"] = 523;
	gates["BT12P_V5"] = 524;
	gates["BT12SMP_V5"] = 525;
	gates["BT12SP_V5"] = 526;
	gates["BT16P_V5"] = 527;
	gates["BT16SMP_V5"] = 528;
	gates["BT16SP_V5"] = 529;
	gates["BT24P_V5"] = 530;
	gates["BT24SMP_V5"] = 531;
	gates["BT24SP_V5"] = 532;
	gates["BU1P_V5"] = 533;
	gates["BU2P_V5"] = 534;
	gates["BU4P_V5"] = 535;
	gates["BU4SMP_V5"] = 536;
	gates["BU8P_V5"] = 537;
	gates["BU8SMP_V5"] = 538;
	gates["BU8SP_V5"] = 539;
	gates["BU12P_V5"] = 540;
	gates["BU12SMP_V5"] = 541;
	gates["BU12SP_V5"] = 542;
	gates["BU16P_V5"] = 543;
	gates["BU16SMP_V5"] = 544;
	gates["BU16SP_V5"] = 545;
	gates["BU24P_V5"] = 546;
	gates["BU24SMP_V5"] = 547;
	gates["BU24SP_V5"] = 548;
	gates["BUDD1P_V5"] = 549;
	gates["BUDD2P_V5"] = 550;
	gates["BUDD4P_V5"] = 551;
	gates["BUDD8P_V5"] = 552;
	gates["BUDD12P_V5"] = 553;
	gates["BUDD16P_V5"] = 554;
	gates["BUDD24P_V5"] = 555;
	gates["BUDU1P_V5"] = 556;
	gates["BUDU2P_V5"] = 557;
	gates["BUDU4P_V5"] = 558;
	gates["BUDU8P_V5"] = 559;
	gates["BUDU12P_V5"] = 560;
	gates["BUDU16P_V5"] = 561;
	gates["BUDU24P_V5"] = 562;
	gates["CBU1P_V5"] = 563;
	gates["CBU2P_V5"] = 564;
	gates["ICCK2P_V5"] = 565;
	gates["ICCK4P_V5"] = 566;
	gates["ICDP_V5"] = 567;
	gates["ICP_V5"] = 568;
	gates["ICUP_V5"] = 569;
	gates["ISDP_V5"] = 570;
	gates["ISP_V5"] = 571;
	gates["ISUP_V5"] = 572;
	gates["ITCK2P_V5"] = 573;
	gates["ITCK4P_V5"] = 574;
	gates["ITDP_V5"] = 575;
	gates["ITP_V5"] = 576;
	gates["ITUP_V5"] = 577;
	gates["INVP"] = 578;
	gates["INVN"] = 579;
}
int getGateType (string gateType) {
		int g;

		// 1= combinatorio
		// 2= FF
		// 3= FF scan
		// 4= memory
		g=gates[gateType];
		 if ((g>=53 && g<=68) || (g>=198 && g<=209)) {
			return 2;
		} else if ((g>=69 && g<=84) || (g>=210 && g<=221)) {
			return 3;
		//PB
		} else if (g==601) {
		        return 4;
		//_PB
		} else {
		//cout << "return 1 ";
		return 1;}
		
		 
		cout << "ERROR!: Parsing library c35, module " << gateType << " not defined. Aborting.\n";
		exit(-1);
	}

	generic_gate* createCombGate (string gateType, const char* gateName) {
		generic_gate* retval;
		int g;

		g=gates[gateType];
		
		switch(g) {
	case 1 : retval = new c35_ADD21(gateName); break;
	case 2 : retval = new c35_ADD22(gateName); break;
	case 3 : retval = new c35_ADD31(gateName); break;
	case 4 : retval = new c35_ADD32(gateName); break;
	case 5 : retval = new c35_AOI210(gateName); break;
	case 6 : retval = new c35_AOI211(gateName); break;
	case 7 : retval = new c35_AOI2110(gateName); break;
	case 8 : retval = new c35_AOI2111(gateName); break;
	case 9 : retval = new c35_AOI2112(gateName); break;
	case 10 : retval = new c35_AOI212(gateName); break;
	case 11 : retval = new c35_AOI220(gateName); break;
	case 12 : retval = new c35_AOI221(gateName); break;
	case 13 : retval = new c35_AOI222(gateName); break;
	case 14 : retval = new c35_AOI310(gateName); break;
	case 15 : retval = new c35_AOI311(gateName); break;
	case 16 : retval = new c35_AOI312(gateName); break;
	case 17 : retval = new c35_BUF12(gateName); break;
	case 18 : retval = new c35_BUF15(gateName); break;
	case 19 : retval = new c35_BUF2(gateName); break;
	case 20 : retval = new c35_BUF4(gateName); break;
	case 21 : retval = new c35_BUF6(gateName); break;
	case 22 : retval = new c35_BUF8(gateName); break;
	case 23 : retval = new c35_BUFE10(gateName); break;
	case 24 : retval = new c35_BUFE12(gateName); break;
	case 25 : retval = new c35_BUFE15(gateName); break;
	case 26 : retval = new c35_BUFE2(gateName); break;
	case 27 : retval = new c35_BUFE4(gateName); break;
	case 28 : retval = new c35_BUFE6(gateName); break;
	case 29 : retval = new c35_BUFE8(gateName); break;
	case 30 : retval = new c35_BUFT10(gateName); break;
	case 31 : retval = new c35_BUFT12(gateName); break;
	case 32 : retval = new c35_BUFT15(gateName); break;
	case 33 : retval = new c35_BUFT2(gateName); break;
	case 34 : retval = new c35_BUFT4(gateName); break;
	case 35 : retval = new c35_BUFT6(gateName); break;
	case 36 : retval = new c35_BUFT8(gateName); break;
	case 37 : retval = new c35_CLKBU12(gateName); break;
	case 38 : retval = new c35_CLKBU15(gateName); break;
	case 39 : retval = new c35_CLKBU2(gateName); break;
	case 40 : retval = new c35_CLKBU4(gateName); break;
	case 41 : retval = new c35_CLKBU6(gateName); break;
	case 42 : retval = new c35_CLKBU8(gateName); break;
	case 43 : retval = new c35_CLKIN0(gateName); break;
	case 44 : retval = new c35_CLKIN1(gateName); break;
	case 45 : retval = new c35_CLKIN10(gateName); break;
	case 46 : retval = new c35_CLKIN12(gateName); break;
	case 47 : retval = new c35_CLKIN15(gateName); break;
	case 48 : retval = new c35_CLKIN2(gateName); break;
	case 49 : retval = new c35_CLKIN3(gateName); break;
	case 50 : retval = new c35_CLKIN4(gateName); break;
	case 51 : retval = new c35_CLKIN6(gateName); break;
	case 52 : retval = new c35_CLKIN8(gateName); break;
	case 85 : retval = new c35_DL1(gateName); break;
	case 86 : retval = new c35_DL3(gateName); break;
	case 87 : retval = new c35_DLC1(gateName); break;
	case 88 : retval = new c35_DLC3(gateName); break;
	case 89 : retval = new c35_DLCP1(gateName); break;
	case 90 : retval = new c35_DLCP3(gateName); break;
	case 91 : retval = new c35_DLCPQ1(gateName); break;
	case 92 : retval = new c35_DLCPQ3(gateName); break;
	case 93 : retval = new c35_DLCQ1(gateName); break;
	case 94 : retval = new c35_DLCQ3(gateName); break;
	case 95 : retval = new c35_DLP1(gateName); break;
	case 96 : retval = new c35_DLP3(gateName); break;
	case 97 : retval = new c35_DLPQ1(gateName); break;
	case 98 : retval = new c35_DLPQ3(gateName); break;
	case 99 : retval = new c35_DLQ1(gateName); break;
	case 100 : retval = new c35_DLQ3(gateName); break;
	case 101 : retval = new c35_DLY12(gateName); break;
	case 102 : retval = new c35_DLY22(gateName); break;
	case 103 : retval = new c35_DLY32(gateName); break;
	case 104 : retval = new c35_DLY42(gateName); break;
	case 105 : retval = new c35_IMAJ30(gateName); break;
	case 106 : retval = new c35_IMAJ31(gateName); break;
	case 107 : retval = new c35_IMUX20(gateName); break;
	case 108 : retval = new c35_IMUX21(gateName); break;
	case 109 : retval = new c35_IMUX22(gateName); break;
	case 110 : retval = new c35_IMUX23(gateName); break;
	case 111 : retval = new c35_IMUX24(gateName); break;
	case 112 : retval = new c35_IMUX30(gateName); break;
	case 113 : retval = new c35_IMUX31(gateName); break;
	case 114 : retval = new c35_IMUX32(gateName); break;
	case 115 : retval = new c35_IMUX33(gateName); break;
	case 116 : retval = new c35_IMUX40(gateName); break;
	case 117 : retval = new c35_IMUX41(gateName); break;
	case 118 : retval = new c35_IMUX42(gateName); break;
	case 119 : retval = new c35_INV0(gateName); break;
	case 120 : retval = new c35_INV1(gateName); break;
	case 121 : retval = new c35_INV10(gateName); break;
	case 122 : retval = new c35_INV12(gateName); break;
	case 123 : retval = new c35_INV15(gateName); break;
	case 124 : retval = new c35_INV2(gateName); break;
	case 125 : retval = new c35_INV3(gateName); break;
	case 126 : retval = new c35_INV4(gateName); break;
	case 127 : retval = new c35_INV6(gateName); break;
	case 128 : retval = new c35_INV8(gateName); break;
	case 129 : retval = new c35_JK1(gateName); break;
	case 130 : retval = new c35_JK3(gateName); break;
	case 131 : retval = new c35_JKC1(gateName); break;
	case 132 : retval = new c35_JKC3(gateName); break;
	case 133 : retval = new c35_JKCP1(gateName); break;
	case 134 : retval = new c35_JKCP3(gateName); break;
	case 135 : retval = new c35_JKP1(gateName); break;
	case 136 : retval = new c35_JKP3(gateName); break;
	case 137 : retval = new c35_JKS1(gateName); break;
	case 138 : retval = new c35_JKS3(gateName); break;
	case 139 : retval = new c35_JKSC1(gateName); break;
	case 140 : retval = new c35_JKSC3(gateName); break;
	case 141 : retval = new c35_JKSCP1(gateName); break;
	case 142 : retval = new c35_JKSCP3(gateName); break;
	case 143 : retval = new c35_JKSP1(gateName); break;
	case 144 : retval = new c35_JKSP3(gateName); break;
	case 145 : retval = new c35_MAJ31(gateName); break;
	case 146 : retval = new c35_MAJ32(gateName); break;
	case 147 : retval = new c35_MUX21(gateName); break;
	case 148 : retval = new c35_MUX22(gateName); break;
	case 149 : retval = new c35_MUX24(gateName); break;
	case 150 : retval = new c35_MUX26(gateName); break;
	case 151 : retval = new c35_MUX31(gateName); break;
	case 152 : retval = new c35_MUX32(gateName); break;
	case 153 : retval = new c35_MUX33(gateName); break;
	case 154 : retval = new c35_MUX34(gateName); break;
	case 155 : retval = new c35_MUX41(gateName); break;
	case 156 : retval = new c35_MUX42(gateName); break;
	case 157 : retval = new c35_MUX43(gateName); break;
	case 158 : retval = new c35_NAND20(gateName); break;
	case 159 : retval = new c35_NAND21(gateName); break;
	case 160 : retval = new c35_NAND22(gateName); break;
	case 161 : retval = new c35_NAND23(gateName); break;
	case 162 : retval = new c35_NAND24(gateName); break;
	case 163 : retval = new c35_NAND26(gateName); break;
	case 164 : retval = new c35_NAND28(gateName); break;
	case 165 : retval = new c35_NAND30(gateName); break;
	case 166 : retval = new c35_NAND31(gateName); break;
	case 167 : retval = new c35_NAND32(gateName); break;
	case 168 : retval = new c35_NAND33(gateName); break;
	case 169 : retval = new c35_NAND34(gateName); break;
	case 170 : retval = new c35_NAND40(gateName); break;
	case 171 : retval = new c35_NAND41(gateName); break;
	case 172 : retval = new c35_NAND42(gateName); break;
	case 173 : retval = new c35_NAND43(gateName); break;
	case 174 : retval = new c35_NOR20(gateName); break;
	case 175 : retval = new c35_NOR21(gateName); break;
	case 176 : retval = new c35_NOR22(gateName); break;
	case 177 : retval = new c35_NOR23(gateName); break;
	case 178 : retval = new c35_NOR24(gateName); break;
	case 179 : retval = new c35_NOR30(gateName); break;
	case 180 : retval = new c35_NOR31(gateName); break;
	case 181 : retval = new c35_NOR32(gateName); break;
	case 182 : retval = new c35_NOR33(gateName); break;
	case 183 : retval = new c35_NOR40(gateName); break;
	case 184 : retval = new c35_NOR41(gateName); break;
	case 185 : retval = new c35_NOR42(gateName); break;
	case 186 : retval = new c35_OAI210(gateName); break;
	case 187 : retval = new c35_OAI211(gateName); break;
	case 188 : retval = new c35_OAI2110(gateName); break;
	case 189 : retval = new c35_OAI2111(gateName); break;
	case 190 : retval = new c35_OAI2112(gateName); break;
	case 191 : retval = new c35_OAI212(gateName); break;
	case 192 : retval = new c35_OAI220(gateName); break;
	case 193 : retval = new c35_OAI221(gateName); break;
	case 194 : retval = new c35_OAI222(gateName); break;
	case 195 : retval = new c35_OAI310(gateName); break;
	case 196 : retval = new c35_OAI311(gateName); break;
	case 197 : retval = new c35_OAI312(gateName); break;
	case 198 : retval = new c35_TFC1(gateName); break;
	case 199 : retval = new c35_TFC3(gateName); break;
	case 200 : retval = new c35_TFCP1(gateName); break;
	case 201 : retval = new c35_TFCP3(gateName); break;
	case 202 : retval = new c35_TFEC1(gateName); break;
	case 203 : retval = new c35_TFEC3(gateName); break;
	case 204 : retval = new c35_TFECP1(gateName); break;
	case 205 : retval = new c35_TFECP3(gateName); break;
	case 206 : retval = new c35_TFEP1(gateName); break;
	case 207 : retval = new c35_TFEP3(gateName); break;
	case 208 : retval = new c35_TFP1(gateName); break;
	case 209 : retval = new c35_TFP3(gateName); break;
	case 210 : retval = new c35_TFSC1(gateName); break;
	case 211 : retval = new c35_TFSC3(gateName); break;
	case 212 : retval = new c35_TFSCP1(gateName); break;
	case 213 : retval = new c35_TFSCP3(gateName); break;
	case 214 : retval = new c35_TFSEC1(gateName); break;
	case 215 : retval = new c35_TFSEC3(gateName); break;
	case 216 : retval = new c35_TFSECP1(gateName); break;
	case 217 : retval = new c35_TFSECP3(gateName); break;
	case 218 : retval = new c35_TFSEP1(gateName); break;
	case 219 : retval = new c35_TFSEP3(gateName); break;
	case 220 : retval = new c35_TFSP1(gateName); break;
	case 221 : retval = new c35_TFSP3(gateName); break;
	case 222 : retval = new c35_XNR20(gateName); break;
	case 223 : retval = new c35_XNR21(gateName); break;
	case 224 : retval = new c35_XNR22(gateName); break;
	case 225 : retval = new c35_XNR30(gateName); break;
	case 226 : retval = new c35_XNR31(gateName); break;
	case 227 : retval = new c35_XNR40(gateName); break;
	case 228 : retval = new c35_XNR41(gateName); break;
	case 229 : retval = new c35_XOR20(gateName); break;
	case 230 : retval = new c35_XOR21(gateName); break;
	case 231 : retval = new c35_XOR22(gateName); break;
	case 232 : retval = new c35_XOR30(gateName); break;
	case 233 : retval = new c35_XOR31(gateName); break;
	case 234 : retval = new c35_XOR40(gateName); break;
	case 235 : retval = new c35_XOR41(gateName); break;
	case 236 : retval = new c35_BBC1P(gateName); break;
	case 237 : retval = new c35_BBC4P(gateName); break;
	case 238 : retval = new c35_BBC4SMP(gateName); break;
	case 239 : retval = new c35_BBC8P(gateName); break;
	case 240 : retval = new c35_BBC8SMP(gateName); break;
	case 241 : retval = new c35_BBC8SP(gateName); break;
	case 242 : retval = new c35_BBC16P(gateName); break;
	case 243 : retval = new c35_BBC16SMP(gateName); break;
	case 244 : retval = new c35_BBC16SP(gateName); break;
	case 245 : retval = new c35_BBC24P(gateName); break;
	case 246 : retval = new c35_BBC24SMP(gateName); break;
	case 247 : retval = new c35_BBC24SP(gateName); break;
	case 248 : retval = new c35_BBCD1P(gateName); break;
	case 249 : retval = new c35_BBCD4P(gateName); break;
	case 250 : retval = new c35_BBCD4SMP(gateName); break;
	case 251 : retval = new c35_BBCD8P(gateName); break;
	case 252 : retval = new c35_BBCD8SMP(gateName); break;
	case 253 : retval = new c35_BBCD8SP(gateName); break;
	case 254 : retval = new c35_BBCD16P(gateName); break;
	case 255 : retval = new c35_BBCD16SMP(gateName); break;
	case 256 : retval = new c35_BBCD16SP(gateName); break;
	case 257 : retval = new c35_BBCD24P(gateName); break;
	case 258 : retval = new c35_BBCD24SMP(gateName); break;
	case 259 : retval = new c35_BBCD24SP(gateName); break;
	case 260 : retval = new c35_BBCU1P(gateName); break;
	case 261 : retval = new c35_BBCU4P(gateName); break;
	case 262 : retval = new c35_BBCU4SMP(gateName); break;
	case 263 : retval = new c35_BBCU8P(gateName); break;
	case 264 : retval = new c35_BBCU8SMP(gateName); break;
	case 265 : retval = new c35_BBCU8SP(gateName); break;
	case 266 : retval = new c35_BBCU16P(gateName); break;
	case 267 : retval = new c35_BBCU16SMP(gateName); break;
	case 268 : retval = new c35_BBCU16SP(gateName); break;
	case 269 : retval = new c35_BBCU24P(gateName); break;
	case 270 : retval = new c35_BBCU24SMP(gateName); break;
	case 271 : retval = new c35_BBCU24SP(gateName); break;
	case 272 : retval = new c35_BBS1P(gateName); break;
	case 273 : retval = new c35_BBS4P(gateName); break;
	case 274 : retval = new c35_BBS4SMP(gateName); break;
	case 275 : retval = new c35_BBS8P(gateName); break;
	case 276 : retval = new c35_BBS8SMP(gateName); break;
	case 277 : retval = new c35_BBS8SP(gateName); break;
	case 278 : retval = new c35_BBS16P(gateName); break;
	case 279 : retval = new c35_BBS16SMP(gateName); break;
	case 280 : retval = new c35_BBS16SP(gateName); break;
	case 281 : retval = new c35_BBS24P(gateName); break;
	case 282 : retval = new c35_BBS24SMP(gateName); break;
	case 283 : retval = new c35_BBS24SP(gateName); break;
	case 284 : retval = new c35_BBSD1P(gateName); break;
	case 285 : retval = new c35_BBSD4P(gateName); break;
	case 286 : retval = new c35_BBSD4SMP(gateName); break;
	case 287 : retval = new c35_BBSD8P(gateName); break;
	case 288 : retval = new c35_BBSD8SMP(gateName); break;
	case 289 : retval = new c35_BBSD8SP(gateName); break;
	case 290 : retval = new c35_BBSD16P(gateName); break;
	case 291 : retval = new c35_BBSD16SMP(gateName); break;
	case 292 : retval = new c35_BBSD16SP(gateName); break;
	case 293 : retval = new c35_BBSD24P(gateName); break;
	case 294 : retval = new c35_BBSD24SMP(gateName); break;
	case 295 : retval = new c35_BBSD24SP(gateName); break;
	case 296 : retval = new c35_BBSU1P(gateName); break;
	case 297 : retval = new c35_BBSU4P(gateName); break;
	case 298 : retval = new c35_BBSU4SMP(gateName); break;
	case 299 : retval = new c35_BBSU8P(gateName); break;
	case 300 : retval = new c35_BBSU8SMP(gateName); break;
	case 301 : retval = new c35_BBSU8SP(gateName); break;
	case 302 : retval = new c35_BBSU16P(gateName); break;
	case 303 : retval = new c35_BBSU16SMP(gateName); break;
	case 304 : retval = new c35_BBSU16SP(gateName); break;
	case 305 : retval = new c35_BBSU24P(gateName); break;
	case 306 : retval = new c35_BBSU24SMP(gateName); break;
	case 307 : retval = new c35_BBSU24SP(gateName); break;
	case 308 : retval = new c35_BBT1P(gateName); break;
	case 309 : retval = new c35_BBT4P(gateName); break;
	case 310 : retval = new c35_BBT4SMP(gateName); break;
	case 311 : retval = new c35_BBT8P(gateName); break;
	case 312 : retval = new c35_BBT8SMP(gateName); break;
	case 313 : retval = new c35_BBT8SP(gateName); break;
	case 314 : retval = new c35_BBT16P(gateName); break;
	case 315 : retval = new c35_BBT16SMP(gateName); break;
	case 316 : retval = new c35_BBT16SP(gateName); break;
	case 317 : retval = new c35_BBT24P(gateName); break;
	case 318 : retval = new c35_BBT24SMP(gateName); break;
	case 319 : retval = new c35_BBT24SP(gateName); break;
	case 320 : retval = new c35_BBTD1P(gateName); break;
	case 321 : retval = new c35_BBTD4P(gateName); break;
	case 322 : retval = new c35_BBTD4SMP(gateName); break;
	case 323 : retval = new c35_BBTD8P(gateName); break;
	case 324 : retval = new c35_BBTD8SMP(gateName); break;
	case 325 : retval = new c35_BBTD8SP(gateName); break;
	case 326 : retval = new c35_BBTD16P(gateName); break;
	case 327 : retval = new c35_BBTD16SMP(gateName); break;
	case 328 : retval = new c35_BBTD16SP(gateName); break;
	case 329 : retval = new c35_BBTD24P(gateName); break;
	case 330 : retval = new c35_BBTD24SMP(gateName); break;
	case 331 : retval = new c35_BBTD24SP(gateName); break;
	case 332 : retval = new c35_BBTU1P(gateName); break;
	case 333 : retval = new c35_BBTU4P(gateName); break;
	case 334 : retval = new c35_BBTU4SMP(gateName); break;
	case 335 : retval = new c35_BBTU8P(gateName); break;
	case 336 : retval = new c35_BBTU8SMP(gateName); break;
	case 337 : retval = new c35_BBTU8SP(gateName); break;
	case 338 : retval = new c35_BBTU16P(gateName); break;
	case 339 : retval = new c35_BBTU16SMP(gateName); break;
	case 340 : retval = new c35_BBTU16SP(gateName); break;
	case 341 : retval = new c35_BBTU24P(gateName); break;
	case 342 : retval = new c35_BBTU24SMP(gateName); break;
	case 343 : retval = new c35_BBTU24SP(gateName); break;
	case 344 : retval = new c35_BT1P(gateName); break;
	case 345 : retval = new c35_BT2P(gateName); break;
	case 346 : retval = new c35_BT4P(gateName); break;
	case 347 : retval = new c35_BT4SMP(gateName); break;
	case 348 : retval = new c35_BT8P(gateName); break;
	case 349 : retval = new c35_BT8SMP(gateName); break;
	case 350 : retval = new c35_BT8SP(gateName); break;
	case 351 : retval = new c35_BT12P(gateName); break;
	case 352 : retval = new c35_BT12SMP(gateName); break;
	case 353 : retval = new c35_BT12SP(gateName); break;
	case 354 : retval = new c35_BT16P(gateName); break;
	case 355 : retval = new c35_BT16SMP(gateName); break;
	case 356 : retval = new c35_BT16SP(gateName); break;
	case 357 : retval = new c35_BT24P(gateName); break;
	case 358 : retval = new c35_BT24SMP(gateName); break;
	case 359 : retval = new c35_BT24SP(gateName); break;
	case 360 : retval = new c35_BU1P(gateName); break;
	case 361 : retval = new c35_BU2P(gateName); break;
	case 362 : retval = new c35_BU4P(gateName); break;
	case 363 : retval = new c35_BU4SMP(gateName); break;
	case 364 : retval = new c35_BU8P(gateName); break;
	case 365 : retval = new c35_BU8SMP(gateName); break;
	case 366 : retval = new c35_BU8SP(gateName); break;
	case 367 : retval = new c35_BU12P(gateName); break;
	case 368 : retval = new c35_BU12SMP(gateName); break;
	case 369 : retval = new c35_BU12SP(gateName); break;
	case 370 : retval = new c35_BU16P(gateName); break;
	case 371 : retval = new c35_BU16SMP(gateName); break;
	case 372 : retval = new c35_BU16SP(gateName); break;
	case 373 : retval = new c35_BU24P(gateName); break;
	case 374 : retval = new c35_BU24SMP(gateName); break;
	case 375 : retval = new c35_BU24SP(gateName); break;
	case 376 : retval = new c35_BUDD1P(gateName); break;
	case 377 : retval = new c35_BUDD2P(gateName); break;
	case 378 : retval = new c35_BUDD4P(gateName); break;
	case 379 : retval = new c35_BUDD8P(gateName); break;
	case 380 : retval = new c35_BUDD12P(gateName); break;
	case 381 : retval = new c35_BUDD16P(gateName); break;
	case 382 : retval = new c35_BUDD24P(gateName); break;
	case 383 : retval = new c35_BUDU1P(gateName); break;
	case 384 : retval = new c35_BUDU2P(gateName); break;
	case 385 : retval = new c35_BUDU4P(gateName); break;
	case 386 : retval = new c35_BUDU8P(gateName); break;
	case 387 : retval = new c35_BUDU12P(gateName); break;
	case 388 : retval = new c35_BUDU16P(gateName); break;
	case 389 : retval = new c35_BUDU24P(gateName); break;
	case 390 : retval = new c35_CBU1P(gateName); break;
	case 391 : retval = new c35_CBU2P(gateName); break;
	case 392 : retval = new c35_ICCK2P(gateName); break;
	case 393 : retval = new c35_ICCK4P(gateName); break;
	case 394 : retval = new c35_ICCK8P(gateName); break;
	case 395 : retval = new c35_ICCK16P(gateName); break;
	case 396 : retval = new c35_ICDP(gateName); break;
	case 397 : retval = new c35_ICP(gateName); break;
	case 398 : retval = new c35_ICUP(gateName); break;
	case 399 : retval = new c35_ISDP(gateName); break;
	case 400 : retval = new c35_ISP(gateName); break;
	case 401 : retval = new c35_ISUP(gateName); break;
	case 402 : retval = new c35_ITCK2P(gateName); break;
	case 403 : retval = new c35_ITCK4P(gateName); break;
	case 404 : retval = new c35_ITCK8P(gateName); break;
	case 405 : retval = new c35_ITCK16P(gateName); break;
	case 406 : retval = new c35_ITDP(gateName); break;
	case 407 : retval = new c35_ITP(gateName); break;
	case 408 : retval = new c35_ITUP(gateName); break;
	case 409 : retval = new c35_BBC1P_V5(gateName); break;
	case 410 : retval = new c35_BBC4P_V5(gateName); break;
	case 411 : retval = new c35_BBC4SMP_V5(gateName); break;
	case 412 : retval = new c35_BBC8P_V5(gateName); break;
	case 413 : retval = new c35_BBC8SMP_V5(gateName); break;
	case 414 : retval = new c35_BBC8SP_V5(gateName); break;
	case 415 : retval = new c35_BBC16P_V5(gateName); break;
	case 416 : retval = new c35_BBC16SMP_V5(gateName); break;
	case 417 : retval = new c35_BBC16SP_V5(gateName); break;
	case 418 : retval = new c35_BBC24P_V5(gateName); break;
	case 419 : retval = new c35_BBC24SMP_V5(gateName); break;
	case 420 : retval = new c35_BBC24SP_V5(gateName); break;
	case 421 : retval = new c35_BBCD1P_V5(gateName); break;
	case 422 : retval = new c35_BBCD4P_V5(gateName); break;
	case 423 : retval = new c35_BBCD4SMP_V5(gateName); break;
	case 424 : retval = new c35_BBCD8P_V5(gateName); break;
	case 425 : retval = new c35_BBCD8SMP_V5(gateName); break;
	case 426 : retval = new c35_BBCD8SP_V5(gateName); break;
	case 427 : retval = new c35_BBCD16P_V5(gateName); break;
	case 428 : retval = new c35_BBCD16SMP_V5(gateName); break;
	case 429 : retval = new c35_BBCD16SP_V5(gateName); break;
	case 430 : retval = new c35_BBCD24P_V5(gateName); break;
	case 431 : retval = new c35_BBCD24SMP_V5(gateName); break;
	case 432 : retval = new c35_BBCD24SP_V5(gateName); break;
	case 433 : retval = new c35_BBCU1P_V5(gateName); break;
	case 434 : retval = new c35_BBCU4P_V5(gateName); break;
	case 435 : retval = new c35_BBCU4SMP_V5(gateName); break;
	case 436 : retval = new c35_BBCU8P_V5(gateName); break;
	case 437 : retval = new c35_BBCU8SMP_V5(gateName); break;
	case 438 : retval = new c35_BBCU8SP_V5(gateName); break;
	case 439 : retval = new c35_BBCU16P_V5(gateName); break;
	case 440 : retval = new c35_BBCU16SMP_V5(gateName); break;
	case 441 : retval = new c35_BBCU16SP_V5(gateName); break;
	case 442 : retval = new c35_BBCU24P_V5(gateName); break;
	case 443 : retval = new c35_BBCU24SMP_V5(gateName); break;
	case 444 : retval = new c35_BBCU24SP_V5(gateName); break;
	case 445 : retval = new c35_BBS1P_V5(gateName); break;
	case 446 : retval = new c35_BBS4P_V5(gateName); break;
	case 447 : retval = new c35_BBS4SMP_V5(gateName); break;
	case 448 : retval = new c35_BBS8P_V5(gateName); break;
	case 449 : retval = new c35_BBS8SMP_V5(gateName); break;
	case 450 : retval = new c35_BBS8SP_V5(gateName); break;
	case 451 : retval = new c35_BBS16P_V5(gateName); break;
	case 452 : retval = new c35_BBS16SMP_V5(gateName); break;
	case 453 : retval = new c35_BBS16SP_V5(gateName); break;
	case 454 : retval = new c35_BBS24P_V5(gateName); break;
	case 455 : retval = new c35_BBS24SMP_V5(gateName); break;
	case 456 : retval = new c35_BBS24SP_V5(gateName); break;
	case 457 : retval = new c35_BBSD1P_V5(gateName); break;
	case 458 : retval = new c35_BBSD4P_V5(gateName); break;
	case 459 : retval = new c35_BBSD4SMP_V5(gateName); break;
	case 460 : retval = new c35_BBSD8P_V5(gateName); break;
	case 461 : retval = new c35_BBSD8SMP_V5(gateName); break;
	case 462 : retval = new c35_BBSD8SP_V5(gateName); break;
	case 463 : retval = new c35_BBSD16P_V5(gateName); break;
	case 464 : retval = new c35_BBSD16SMP_V5(gateName); break;
	case 465 : retval = new c35_BBSD16SP_V5(gateName); break;
	case 466 : retval = new c35_BBSD24P_V5(gateName); break;
	case 467 : retval = new c35_BBSD24SMP_V5(gateName); break;
	case 468 : retval = new c35_BBSD24SP_V5(gateName); break;
	case 469 : retval = new c35_BBSU1P_V5(gateName); break;
	case 470 : retval = new c35_BBSU4P_V5(gateName); break;
	case 471 : retval = new c35_BBSU4SMP_V5(gateName); break;
	case 472 : retval = new c35_BBSU8P_V5(gateName); break;
	case 473 : retval = new c35_BBSU8SMP_V5(gateName); break;
	case 474 : retval = new c35_BBSU8SP_V5(gateName); break;
	case 475 : retval = new c35_BBSU16P_V5(gateName); break;
	case 476 : retval = new c35_BBSU16SMP_V5(gateName); break;
	case 477 : retval = new c35_BBSU16SP_V5(gateName); break;
	case 478 : retval = new c35_BBSU24P_V5(gateName); break;
	case 479 : retval = new c35_BBSU24SMP_V5(gateName); break;
	case 480 : retval = new c35_BBSU24SP_V5(gateName); break;
	case 481 : retval = new c35_BBT1P_V5(gateName); break;
	case 482 : retval = new c35_BBT4P_V5(gateName); break;
	case 483 : retval = new c35_BBT4SMP_V5(gateName); break;
	case 484 : retval = new c35_BBT8P_V5(gateName); break;
	case 485 : retval = new c35_BBT8SMP_V5(gateName); break;
	case 486 : retval = new c35_BBT8SP_V5(gateName); break;
	case 487 : retval = new c35_BBT16P_V5(gateName); break;
	case 488 : retval = new c35_BBT16SMP_V5(gateName); break;
	case 489 : retval = new c35_BBT16SP_V5(gateName); break;
	case 490 : retval = new c35_BBT24P_V5(gateName); break;
	case 491 : retval = new c35_BBT24SMP_V5(gateName); break;
	case 492 : retval = new c35_BBT24SP_V5(gateName); break;
	case 493 : retval = new c35_BBTD1P_V5(gateName); break;
	case 494 : retval = new c35_BBTD4P_V5(gateName); break;
	case 495 : retval = new c35_BBTD4SMP_V5(gateName); break;
	case 496 : retval = new c35_BBTD8P_V5(gateName); break;
	case 497 : retval = new c35_BBTD8SMP_V5(gateName); break;
	case 498 : retval = new c35_BBTD8SP_V5(gateName); break;
	case 499 : retval = new c35_BBTD16P_V5(gateName); break;
	case 500 : retval = new c35_BBTD16SMP_V5(gateName); break;
	case 501 : retval = new c35_BBTD16SP_V5(gateName); break;
	case 502 : retval = new c35_BBTD24P_V5(gateName); break;
	case 503 : retval = new c35_BBTD24SMP_V5(gateName); break;
	case 504 : retval = new c35_BBTD24SP_V5(gateName); break;
	case 505 : retval = new c35_BBTU1P_V5(gateName); break;
	case 506 : retval = new c35_BBTU4P_V5(gateName); break;
	case 507 : retval = new c35_BBTU4SMP_V5(gateName); break;
	case 508 : retval = new c35_BBTU8P_V5(gateName); break;
	case 509 : retval = new c35_BBTU8SMP_V5(gateName); break;
	case 510 : retval = new c35_BBTU8SP_V5(gateName); break;
	case 511 : retval = new c35_BBTU16P_V5(gateName); break;
	case 512 : retval = new c35_BBTU16SMP_V5(gateName); break;
	case 513 : retval = new c35_BBTU16SP_V5(gateName); break;
	case 514 : retval = new c35_BBTU24P_V5(gateName); break;
	case 515 : retval = new c35_BBTU24SMP_V5(gateName); break;
	case 516 : retval = new c35_BBTU24SP_V5(gateName); break;
	case 517 : retval = new c35_BT1P_V5(gateName); break;
	case 518 : retval = new c35_BT2P_V5(gateName); break;
	case 519 : retval = new c35_BT4P_V5(gateName); break;
	case 520 : retval = new c35_BT4SMP_V5(gateName); break;
	case 521 : retval = new c35_BT8P_V5(gateName); break;
	case 522 : retval = new c35_BT8SMP_V5(gateName); break;
	case 523 : retval = new c35_BT8SP_V5(gateName); break;
	case 524 : retval = new c35_BT12P_V5(gateName); break;
	case 525 : retval = new c35_BT12SMP_V5(gateName); break;
	case 526 : retval = new c35_BT12SP_V5(gateName); break;
	case 527 : retval = new c35_BT16P_V5(gateName); break;
	case 528 : retval = new c35_BT16SMP_V5(gateName); break;
	case 529 : retval = new c35_BT16SP_V5(gateName); break;
	case 530 : retval = new c35_BT24P_V5(gateName); break;
	case 531 : retval = new c35_BT24SMP_V5(gateName); break;
	case 532 : retval = new c35_BT24SP_V5(gateName); break;
	case 533 : retval = new c35_BU1P_V5(gateName); break;
	case 534 : retval = new c35_BU2P_V5(gateName); break;
	case 535 : retval = new c35_BU4P_V5(gateName); break;
	case 536 : retval = new c35_BU4SMP_V5(gateName); break;
	case 537 : retval = new c35_BU8P_V5(gateName); break;
	case 538 : retval = new c35_BU8SMP_V5(gateName); break;
	case 539 : retval = new c35_BU8SP_V5(gateName); break;
	case 540 : retval = new c35_BU12P_V5(gateName); break;
	case 541 : retval = new c35_BU12SMP_V5(gateName); break;
	case 542 : retval = new c35_BU12SP_V5(gateName); break;
	case 543 : retval = new c35_BU16P_V5(gateName); break;
	case 544 : retval = new c35_BU16SMP_V5(gateName); break;
	case 545 : retval = new c35_BU16SP_V5(gateName); break;
	case 546 : retval = new c35_BU24P_V5(gateName); break;
	case 547 : retval = new c35_BU24SMP_V5(gateName); break;
	case 548 : retval = new c35_BU24SP_V5(gateName); break;
	case 549 : retval = new c35_BUDD1P_V5(gateName); break;
	case 550 : retval = new c35_BUDD2P_V5(gateName); break;
	case 551 : retval = new c35_BUDD4P_V5(gateName); break;
	case 552 : retval = new c35_BUDD8P_V5(gateName); break;
	case 553 : retval = new c35_BUDD12P_V5(gateName); break;
	case 554 : retval = new c35_BUDD16P_V5(gateName); break;
	case 555 : retval = new c35_BUDD24P_V5(gateName); break;
	case 556 : retval = new c35_BUDU1P_V5(gateName); break;
	case 557 : retval = new c35_BUDU2P_V5(gateName); break;
	case 558 : retval = new c35_BUDU4P_V5(gateName); break;
	case 559 : retval = new c35_BUDU8P_V5(gateName); break;
	case 560 : retval = new c35_BUDU12P_V5(gateName); break;
	case 561 : retval = new c35_BUDU16P_V5(gateName); break;
	case 562 : retval = new c35_BUDU24P_V5(gateName); break;
	case 563 : retval = new c35_CBU1P_V5(gateName); break;
	case 564 : retval = new c35_CBU2P_V5(gateName); break;
	case 565 : retval = new c35_ICCK2P_V5(gateName); break;
	case 566 : retval = new c35_ICCK4P_V5(gateName); break;
	case 567 : retval = new c35_ICDP_V5(gateName); break;
	case 568 : retval = new c35_ICP_V5(gateName); break;
	case 569 : retval = new c35_ICUP_V5(gateName); break;
	case 570 : retval = new c35_ISDP_V5(gateName); break;
	case 571 : retval = new c35_ISP_V5(gateName); break;
	case 572 : retval = new c35_ISUP_V5(gateName); break;
	case 573 : retval = new c35_ITCK2P_V5(gateName); break;
	case 574 : retval = new c35_ITCK4P_V5(gateName); break;
	case 575 : retval = new c35_ITDP_V5(gateName); break;
	case 576 : retval = new c35_ITP_V5(gateName); break;
	case 577 : retval = new c35_ITUP_V5(gateName); break;
	case 578 : retval = new c35_INVP(gateName); break;
	case 579 : retval = new c35_INVN(gateName); break;
default : cout << "ERROR !!: Parsing library c35, module " << gateType << " not implemented. Aborting.\n";
			exit(-1);
		}
		return retval;
	}
	
	generic_memory* createMemory (string gateType, const char* gateName) {
		generic_memory* retval;
		int g;

		g=gates[gateType];
		if (g==600) {
		        retval = new SPLPLL_10M_16384x8m16 (gateName);
		} else {
			cout << "ERROR !!!!: Parsing library C35, module " << gateType << " not implemented. Aborting.\n";
			exit(-1);
		}
		return retval;
	}
	
	generic_ff* createSeqGate (string gateType, const char* gateName) {
		generic_ff* retval;
		int g;

		g=gates[gateType];
		if (g==53 || g==54) { 
			retval = new c35_dff (gateName,0,0,0,0, gateType);
		} else if (g==55 || g==56) {
			retval = new c35_dff (gateName,0,1,0,0, gateType);
		} else if (g==57 || g==58) {
			retval = new c35_dff (gateName,0,1,1,0, gateType);
		} else if (g==59 || g==60) {
			retval = new c35_dff (gateName,1,0,0,0, gateType);
		} else if (g==61 || g==62) {
			retval = new c35_dff (gateName,1,1,0,0, gateType);
		} else if (g==63 || g==64) {
			retval = new c35_dff (gateName,1,1,1,0, gateType);
		} else if (g==65 || g==66) {
			retval = new c35_dff (gateName,1,0,1,0, gateType);
		} else if (g==67 || g==68) {
			retval = new c35_dff (gateName,0,0,1,0, gateType);
		} else if (g==69 || g==70) { 
			retval = new c35_dff (gateName,0,0,0,1, gateType);
		} else if (g==71 || g==72) {
			retval = new c35_dff (gateName,0,1,0,1, gateType);
		} else if (g==73 || g==74) {
			retval = new c35_dff (gateName,0,1,1,1, gateType);
		} else if (g==75 || g==76) {
			retval = new c35_dff (gateName,1,0,0,1, gateType);
		} else if (g==77 || g==78) {
			retval = new c35_dff (gateName,1,1,0,1, gateType);
		} else if (g==79 || g==80) {
			retval = new c35_dff (gateName,1,1,1,1, gateType);
		} else if (g==81 || g==82) {
			retval = new c35_dff (gateName,1,0,1,1, gateType);
		} else if (g==83 || g==84) {
			retval = new c35_dff (gateName,0,0,1,1, gateType);
		} else if (g==198 || g==199) {
			retval = new c35_tff (gateName,0,1,0,0, gateType);
		} else if (g==200 || g==201) {
			retval = new c35_tff (gateName,0,1,1,0, gateType);
		} else if (g==202 || g==203) {
			retval = new c35_tff (gateName,1,1,0,0, gateType);
		} else if (g==204 || g==205) {
			retval = new c35_tff (gateName,1,1,1,0, gateType);
		} else if (g==206 || g==207) {
			retval = new c35_tff (gateName,1,0,1,0, gateType);
		} else if (g==208 || g==209) {
			retval = new c35_tff (gateName,0,0,1,0, gateType);
		} else if (g==214 || g==215) {
			retval = new c35_tff (gateName,1,1,0,1, gateType);
		}  else {
			cout << "ERROR !!!: Parsing library C35, module " << gateType << " not implemented. Aborting.\n";
			exit(-1);
		}
		return retval;
	}
};

#endif
